package com.fp.persistence.pgeneral.gene;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.Query;

import java.io.Serializable;
import javax.persistence.Table;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Transient;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TGENECOMPANY
 */
@Entity(name = "TgeneCompany")
@Table(name = "TGENECOMPANY")
public class TgeneCompany extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable,Cache {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgeneCompany
	 */
	@Id
	@Column(name = "COMPANYCODE", nullable = false, updatable = false)
	private Integer pk;
	@Version
	@Column(name = "RECORDVERSION", nullable = true)
	/**
	 * Optimistic locking del registro
	 */
	private Integer recordversion;

	@Column(name = "LEGALCURRENCY", nullable = true)
	/**
	 * Moneda oficial de la compania.
	 */
	private String legalcurrency;

	@Column(name = "PERSONCODE", nullable = true)
	/**
	 * Codigo de persona
	 */
	private Integer personcode;

	@Column(name = "ACTIVE", nullable = true)
	/**
	 * Y indica que la compania esta activa 
	 */
	private String active;

	@Column(name = "ACCOSERVER", nullable = true)
	/**
	 * Y indica que ejecuta el servidor contable, N no ejecuta
	 */
	private String accoserver;

	/** Contructor por defecto */
	public TgeneCompany() {
	}

	/**
	 * Contructor de TgeneCompany
	 * 
	 * @param pPk Clave Primaria del entity
	 */
	public TgeneCompany(Integer pPk) {
		this();
		pk = pPk;
	}

	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager referencia de la session a obtener datos del bean.
	 * @param pKey Caleve primaria del bean.
	 * @return TgeneCompany
	 */
	public static TgeneCompany find(EntityManager pEntityManager, Object pKey) throws Exception {
		TgeneCompany obj = pEntityManager.find(TgeneCompany.class, pKey);
		return obj;
	}

	/**
	 * Entrega la Clave primaria de TgeneCompany
	 * 
	 * @return El objeto que referencia a la Clave primaria de TgeneCompany
	 */
	public Integer getPk() {
		return pk;
	}

	/**
	 * Fija un nuevo valor a la Clave primaria de TgeneCompany
	 * 
	 * @param pPk El objeto que referencia a la nueva Clave primaria de
	 *            TgeneCompany
	 */
	public void setPk(Integer pPk) {
		pk = pPk;
	}

	/**
	 * Obtiene el valor de recordversion
	 * 
	 * @return valor de recordversion
	 */
	public Integer getRecordversion() {
		return recordversion;
	}

	/**
	 * Fija el valor de recordversion
	 * 
	 * @param pRecordversion nuevo Valor de recordversion
	 */
	public void setRecordversion(Integer pRecordversion) {
		recordversion = pRecordversion;
	}

	/**
	 * Obtiene el valor de legalcurrency
	 * 
	 * @return valor de legalcurrency
	 */
	public String getLegalcurrency() {
		return legalcurrency;
	}

	/**
	 * Fija el valor de legalcurrency
	 * 
	 * @param pLegalcurrency nuevo Valor de legalcurrency
	 */
	public void setLegalcurrency(String pLegalcurrency) {
		legalcurrency = pLegalcurrency;
	}

	/**
	 * Obtiene el valor de personcode
	 * 
	 * @return valor de personcode
	 */
	public Integer getPersoncode() {
		return personcode;
	}

	/**
	 * Fija el valor de personcode
	 * 
	 * @param pPersoncode nuevo Valor de personcode
	 */
	public void setPersoncode(Integer pPersoncode) {
		personcode = pPersoncode;
	}

	/**
	 * Obtiene el valor de active
	 * 
	 * @return valor de active
	 */
	public String getActive() {
		return active;
	}

	/**
	 * Fija el valor de active
	 * 
	 * @param pActive nuevo Valor de active
	 */
	public void setActive(String pActive) {
		active = pActive;
	}

	/**
	 * Obtiene el valor de accoserver
	 * 
	 * @return valor de accoserver
	 */
	public String getAccoserver() {
		return accoserver;
	}

	/**
	 * Fija el valor de accoserver
	 * 
	 * @param pAccoserver nuevo Valor de accoserver
	 */
	public void setAccoserver(String pAccoserver) {
		accoserver = pAccoserver;
	}

	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgeneCompany))
			return false;
		TgeneCompany that = (TgeneCompany) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}

	/**
	 * Implementación del metodo hashCode de la la entidad TgeneCompany
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}

	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}

	/** Implementación de la creación de un bean en blanco TgeneCompany */
	public Object createInstance() {
		TgeneCompany instance = new TgeneCompany();
		return instance;
	}

	/**
	 * Clona la entidad TgeneCompany
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgeneCompany p = (TgeneCompany) this.clone();
		return p;
	}
	
	
	//METODOS MANUALES
	
	private static final String sql ="from TgeneCompany t where t.active = 'Y' ";
	
	/**
	 * Metodo que entrega una lista de companias que estan definidas en la aplicacion. 
	 * @param pEntityManager  Referecnia a una session de base de datos.
	 * @return  List<TgeneCompany>
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public static List<TgeneCompany> find(EntityManager pEntityManager) throws Exception{
		List<TgeneCompany> ldata = null;
		Query qry = pEntityManager.createQuery(sql);
		ldata = qry.getResultList();		
		return ldata;
	}
}
